From 61a0a80ee9ff58c130cfef9363e98d16e4bde2e9 Mon Sep 17 00:00:00 2001
From: bings <bings@codeaurora.org>
Date: Mon, 13 Apr 2020 11:29:58 +0800
Subject: [PATCH 55/63] fixing dfs master issue

removing wrong dfs checks and adding correct

Signed-off-by: Kang Xu <kangxu@codeaurora.org>
---
 net/wireless/chan.c | 9 ++++-----
 1 file changed, 4 insertions(+), 5 deletions(-)

diff --git a/net/wireless/chan.c b/net/wireless/chan.c
index 8d85179b9cd7..35444a0e6e06 100644
--- a/net/wireless/chan.c
+++ b/net/wireless/chan.c
@@ -422,8 +422,7 @@ static int cfg80211_get_chans_dfs_required(struct wiphy *wiphy,
 		if (!c)
 			return -EINVAL;
 
-		if ((c->flags & IEEE80211_CHAN_RADAR) &&
-		    !(wiphy->flags & WIPHY_FLAG_DFS_OFFLOAD))
+		if (c->flags & IEEE80211_CHAN_RADAR)
 			return 1;
 	}
 	return 0;
@@ -703,8 +702,7 @@ static bool cfg80211_get_chans_dfs_available(struct wiphy *wiphy,
 		if (c->flags & IEEE80211_CHAN_DISABLED)
 			return false;
 
-		if (!(wiphy->flags & WIPHY_FLAG_DFS_OFFLOAD) &&
-		    (c->flags & IEEE80211_CHAN_RADAR)  &&
+		if ((c->flags & IEEE80211_CHAN_RADAR)  &&
 		    (c->dfs_state != NL80211_DFS_AVAILABLE) &&
 		    !(c->dfs_state == NL80211_DFS_USABLE && dfs_offload))
 			return false;
@@ -817,7 +815,8 @@ static bool cfg80211_secondary_chans_ok(struct wiphy *wiphy,
 
 	for (freq = start_freq; freq <= end_freq; freq += 20) {
 		c = ieee80211_get_channel(wiphy, freq);
-		if (!c || c->flags & prohibited_flags)
+		if (!c || (c->flags & prohibited_flags &&
+		    !(wiphy->flags & WIPHY_FLAG_DFS_OFFLOAD)))
 			return false;
 	}
 
-- 
2.17.1

